#Main Procedure
library(gbm)
WORKINGFOLDER<-"C:/MetaSNPFinder/";
source(paste(WORKINGFOLDER,"lib.R",sep=""));
sink(paste(WORKINGFOLDER, "running.txt",sep=""));
start0 <- Sys.time()
allInteractions<-list();
allFeatures<-list();
allAccuracies<-list();
WINDOW<-500;
DEPTH<-5;
CV<-10;
OVERLAP<-100;
NTREE<-300;
POS<-sort(ceiling(runif(2)*1000))
#For the data chosen from different genome
mergedData<-data.frame(); 
mergedY<-NULL;
STARTCHR<-0;
ENDCHR<-21;
MISSINGFILTER<-25;
randcv<-NULL;
for(iteration in STARTCHR:(ENDCHR+1))
{
	#fileName<-paste("c:/MetaSNPFinder/test/newData/25/25.400.",iteration,".txt",sep="");
	#fileName<-paste("c:/MetaSNPFinder/test/dataset/400/25/25.400.",iteration,".txt",sep="");

	if(iteration > ENDCHR) 
	{
		#run analysis for merged data
		loadeddata<-cbind(mergedData,mergedY);
	}else
	{
		#loadeddata <- getDiabetes(iteration);

		#fileName = paste(WORKINGFOLDER,"AMD2005/amd2005__",iteration,".dat",sep="");
		#fileName = paste(WORKINGFOLDER,"Sim/Genodata",iteration,".txt",sep="");

		#print(fileName);
		#loadeddata <- read.table(fileName,head = T,sep = "\t");

		fileName = paste(WORKINGFOLDER,"Parkinson/chr",iteration,".dat",sep="");
		print(fileName);
		loadeddata <- read.table(fileName,head = T,sep = ",");

		missval<-NULL;
		for(i in 1:(ncol(loadeddata)-1)){ 
			if(sum(is.na(loadeddata[,i]))> MISSINGFILTER){
				missval <- rbind(missval,i)
			}
		}
		if(length(missval) > 0)
			loadeddata <- loadeddata[,-missval];
		for(i in 1:(ncol(loadeddata)-1)){ 
			loadeddata[,i] <- factor(loadeddata[,i])
		}
		randcv <- sample(rep(1:CV, length = nrow(loadeddata)), nrow(loadeddata), replace = FALSE);
	}
	
	#simulation test
	#for(col in 3:(ncol(loadeddata)-1))
	#{
	#	loadeddata[col]<-generateSNP(nrow(loadeddata),0.1);
	#}
	#loadeddata<-loadeddata[, c(POS[1],POS[2],3:(POS[1]-1), 1, (POS[1]+1):(POS[2]-1),2, (POS[2]+1):ncol(loadeddata))];
	
	selectedFeature<-snpFinder(loadeddata,WINDOW,OVERLAP,NTREE,randcv,DEPTH);
	x<-loadeddata[as.character(selectedFeature$name)];
	y <- loadeddata[,ncol(loadeddata)];
	gbmObjectList<-list();
	for (i in sort(unique(randcv)))
	{
		gbmObject<- gbm.fit(x[randcv!=i,],y[randcv!=i],
               	offset = NULL,
               	misc = NULL,
               	distribution = "bernoulli",#bernoulli
               	w = NULL,
               	var.monotone = NULL,
               	n.trees = NTREE,
               	interaction.depth = DEPTH,
               	n.minobsinnode = 10,
               	shrinkage = .1,
               	bag.fraction = 0.5,
               	train.fraction =1,
               	keep.data = TRUE,
               	verbose = FALSE,
               	var.names = NULL,
               	response.name = NULL);
		gbmObjectList[[i]]<-gbmObject;
	}
	#select feature based on marginal effect and joint effect
	pathStats<-extractInteractStats(gbmObjectList,x,NTREE,pathSets,DEPTH);
	selectedFeature<-extractFeature(x, y, pathStats, 0.05);

	#get accuracy statistics
	x<-loadeddata[as.character(selectedFeature$name)];
	y <- loadeddata[,ncol(loadeddata)];
	gbmObjectList<-list();
	for (i in sort(unique(randcv)))
	{
		gbmObject<- gbm.fit(x[randcv!=i,],y[randcv!=i],
               	offset = NULL,
               	misc = NULL,
               	distribution = "bernoulli",#bernoulli
               	w = NULL,
               	var.monotone = NULL,
               	n.trees = NTREE,
               	interaction.depth = DEPTH,
               	n.minobsinnode = 10,
               	shrinkage = .1,
               	bag.fraction = 0.5,
               	train.fraction =1,
               	keep.data = TRUE,
               	verbose = FALSE,
               	var.names = NULL,
               	response.name = NULL);
		gbmObjectList[[i]]<-gbmObject;
	}
	accuracy<-extractAccuracy(gbmObjectList,x,y,randcv);

	allInteractions[[iteration+1]]<-pathStats;
	allFeatures[[iteration+1]]<-selectedFeature;
	allAccuracies[[iteration+1]]<-accuracy;
	if(ncol(mergedData) == 0)
	{
		mergedData<-loadeddata[as.character(selectedFeature$name)];
		mergedY<-y;
	}else
	{
		mergedData<-cbind(mergedData,loadeddata[as.character(selectedFeature$name)]);
	}
}
x<-loadeddata[as.character(selectedFeature$name)];
y <- loadeddata[,ncol(loadeddata)];
datanew<-cbind(x,y);
start1<- Sys.time();
start1 - start0
allInteractions;
allFeatures;
allAccuracies;
sink();
